# include	"BlobMgr.h"


pascal void
FreezeBlob (BlobHandle b)
{
	if (!BlobFrozen (b))
	{
		SetBlobFlags (b, bFreezeMask);
		(**b).fzFlags = ((**b).flags & (bDrawModeMask));
	}
}


pascal void
FreezeBlobSet (BlobSetHandle bSet)
{
	BlobLoopProc1 (&FreezeBlob, bSet);
}


pascal void
ThawBlob (BlobHandle b)
{
	if (BlobFrozen (b))
	{
		ClearBlobFlags (b, bFreezeMask);	/* unfreeze blob */
		HiliteBlob (b, inStatBlob, GetFzBDrawMode (b, inStatBlob));
		HiliteBlob (b, inDragBlob, GetFzBDrawMode (b, inDragBlob));
	}
}


pascal void
ThawBlobSet (BlobSetHandle bSet)
{
	BlobLoopProc1 (&ThawBlob, bSet);
}


/*
 * Display enabled quiet blobs with drawing mode quietMode, display
 * enabled noisy blobs with drawing mode noisyMode.	Freezes all enabled
 * blobs, so should be balanced with a call to ThawBlobs.
 */

pascal void
BlobFeedback (BlobSetHandle bSet, short quietMode, short noisyMode)
{
BlobHandle	b;

	for (b = FirstBlob (bSet); b != nil; b = NextBlob (b))
	{
		FreezeBlob (b);
		HiliteBlob (b, inFullBlob, (BlobQuiet (b) ? quietMode : noisyMode));
	}
}
