/* -------------------------------------------------------------------- */
/*						Blob Draw Proc Installation						*/
/* -------------------------------------------------------------------- */

# include	"BlobMgr.h"


/*
 * Set a blob's draw procedure and regions.  This routine makes COPIES
 * of the regions passed in, so the caller should dispose of the regions
 * it passes in itself.
 */

pascal void
SetProcRgnBlob (BlobHandle b, BDrawProcPtr p, RgnHandle dragRgn, RgnHandle statRgn)
{
	DisposeBlobPic (b);				/* toss any pic the blob might have */
	(**b).bPicProc.bDrawProc = p;	/* install drawing procedure */
	ClearBlobFlags (b, bPicMask);	/* set blob type to proc blob */
	SetBlobRgns (b, dragRgn, statRgn);
	if (BlobEnabled (b))
		DrawBlob (b, inFullBlob);
}


/*
 * Set a blob's draw procedure and regions, where the regions are
 * defined by rectangles.
 */

pascal void
SetProcRectBlob (BlobHandle b, BDrawProcPtr p, Rect *dragRect, Rect *statRect)
{
	DisposeBlobPic (b);				/* toss any pic the blob might have */
	(**b).bPicProc.bDrawProc = p;	/* install drawing procedure */
	ClearBlobFlags (b, bPicMask);	/* set blob type to proc blob */
	SetBlobRects (b, dragRect, statRect);
	if (BlobEnabled (b))
		DrawBlob (b, inFullBlob);
}
